#ifndef	GAME_H_INCLUDED
#define	GAME_H_INCLUDED
/* --------------------------------------------------------------------------------- */
#include <string.h>
#include "main.h"
#include "keys.h"
#include "init.h"
/* --------------------------------------------------------------------------------- */
#define	DIR_LEFT	0
#define	DIR_RIGHT	1
#define	DIR_UP		0
#define	DIR_DOWN	1
/* --------------------------------------------------------------------------------- */
#define	MOVR_IDX	0		//right neigbourn index
#define	MOVL_IDX	1		//left neigbourn index
#define	MOVU_IDX	2		//up neigbourn index
#define	MOVD_IDX	3		//down neigbourn index

#define	CAPV		0		//capture throught vertical
#define	CAPH		1		//capture throught horizontal

const char MOVES[33][4] = {
//	 R 	L 	U 	D		
	{1,0,0,3},		//0
	{2,0,1,4},		//1
	{2,1,2,5},		//2
	{4,3,0,8},		//3
	{5,3,1,9},		//4
	{5,4,2,10},		//5
	{7,6,6,13},		//6
	{8,6,7,14},		//7
	{9,7,3,15},		//8
	{10,8,4,16},	//9
	{11,9,5,17},	//10
	{12,10,11,18},	//11
	{12,11,12,19},	//12
	{14,13,6,20},	//13
	{15,13,7,21},	//14
	{16,14,8,22},	//15
	{17,15,9,23},	//16
	{18,16,10,24},	//17
	{19,17,11,25},	//18
	{19,18,12,26},	//19
	{21,20,13,20},	//20
	{22,20,14,21},	//21
	{23,21,15,27},	//22
	{24,22,16,28},	//23
	{25,23,17,29},	//24
	{26,24,18,25},	//25
	{26,25,19,26},	//26
	{28,27,22,30},	//27
	{29,27,23,31},	//28
	{29,28,24,32},	//29
	{31,30,27,30},	//30
	{32,30,28,31},	//31
	{32,31,29,32}	//32
};

//char moves[33][5];

struct GameState {
	unsigned ptr : 6;
	unsigned dirX : 1;
	unsigned dirY : 1;
	unsigned dirC : 1;
	unsigned isGame : 1;
	u8 matrix[33];
	unsigned snd : 1;
} gameState, gameStateTemp;

				
/* --------------------------------------------------------------------------------- */
void handleGame();
void initGame();
void dirXChange();
void dirYChange();
void saveState();
/* --------------------------------------------------------------------------------- */
#endif